/*
	9 = Sprinkles
	11 = AM Rain
	26 = Cloudy
	28 = Mostly Cloudy
	30 = Partly Cloudy
	34 = Fair
*/
var WeatherData = new Array();
var CityList = new Array();
var nCurrentCity = 0;
try { 
	if(System.Gadget.Settings.read("design") <= 0)
		System.Gadget.Settings.write("design", 1); 
	if(System.Gadget.Settings.read("unit") == "")
		System.Gadget.Settings.write("unit", "c");
	if(System.Gadget.Settings.read("openFlyoutSingle") == undefined)
		System.Gadget.Settings.write("openFlyoutSingle", 1);
} catch(evt) { }

/*CityList.push(new Array('Munich, Bavaria, Germany', 'wc:GMXX0087'));
CityList.push(new Array('Palermo, Sicily, Italy', 'wc:ITXX0055'));
CityList.push(new Array('Hangzhou, CHN', 'wc:CHXX0044'));*/

var myDays = new Array("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday");

var nXmlLoadedCount = 0;

function saveCityList() {
	System.Gadget.Settings.write("cityCount", CityList.length);
	//document.getElementById("debug").innerHTML = "Saved: " + CityList.length+"<hr>";

	for(var i = 0; i < CityList.length; i++) {
		var lstr = CityList[i][0] + "|" + CityList[i][1];
		System.Gadget.Settings.write("cityString"+i, lstr);
		//document.getElementById("debug").innerHTML += lstr+"<hr>";
	}
}

function loadCityList() {
	var cnt = System.Gadget.Settings.read("cityCount");
	//document.getElementById("debug").innerHTML = "OK C:"+cnt+" - "+CityList.length+"<hr>";

	if(cnt > 0) {
		//document.getElementById("debug").innerHTML = "C:"+cnt+" "+CityList.length+"<hr>";
		CityList = new Array();
		for(var i = 0; i < cnt; i++) {
			var astr = System.Gadget.Settings.read("cityString"+i);
			var lstr = astr.split("|");
			if(lstr.length > 1) {
				CityList.push(new Array(lstr[0], lstr[1]));
			}
		}
	} else {
		CityList = new Array();
		CityList.push(new Array('Munich, Bavaria, Germany', 'wc:GMXX0087'));
		CityList.push(new Array('Palermo, Sicily, Italy', 'wc:ITXX0055'));
		CityList.push(new Array('Hangzhou, CHN', 'wc:CHXX0044'));
		saveCityList();
	}
}

function loadWeatherData() {
	nXmlLoadedCount = 0;
	for(i = 0; i < CityList.length; i++) {
		//try {
			loadXMLDoc("http://weather.msn.com/RSS.aspx?wealocations="+CityList[i][1]+"&weadegreetype="+System.Gadget.Settings.read("unit"), CBWeatherXML, CityList[i][0], "text/xml");
			//document.getElementById("debug").innerHTML += i+"-"+nXmlLoadedCount+"<br>";
		//} catch (evt) {}
	}
	window.setTimeout("DispalyWeatherData()", 100);
}

function showNextCity() {
	nCurrentCity++;
	if(nCurrentCity >= CityList.length) nCurrentCity = 0;
	DispalyWeatherData();
}

function showPrevCity() {
	nCurrentCity--;
	if(nCurrentCity < 0) nCurrentCity = CityList.length-1;
	DispalyWeatherData();
}

function DispalyWeatherData() {
	if(CityList[nCurrentCity] && nXmlLoadedCount == CityList.length) {
		ShowWeatherData(CityList[nCurrentCity][0]);
	} else {
		window.setTimeout("DispalyWeatherData()", 100);
	}
}

function CBWeatherXML(xmlData, user) {
	if(xmlData.firstChild == null)
		return;
	var pRSSChannel = xmlData.firstChild.nextSibling.nextSibling.firstChild;
	var strContent = "";
	
	var bFoundTodayInfo = false;
	for(i = 0; i < pRSSChannel.childNodes.length; i++) { // go through the items
		if(pRSSChannel.childNodes[i].nodeName == "item") { // if item, go through it's content
			var pRSSChannelItem = pRSSChannel.childNodes[i];
			var stitle = pRSSChannel.firstChild.firstChild.data + "";
			for(j = 0; j < pRSSChannelItem.childNodes.length; j++) {
				if(pRSSChannelItem.childNodes[j].nodeName == "description") {
					if(!bFoundTodayInfo) {
						var tstr = pRSSChannelItem.childNodes[j].firstChild.data;
						var temp = tstr.match(/....176./i);
						var feels = tstr.match(/\(Feels like.+\)/i);
						var icon = tstr.match(/<img src="http:\/\/st\.msn\.com\/as\/wea3\/i\/en-US\/law\/.+><br/i);
						var iconlocation = "";
						var condition = tstr.match(/alt=".+" t/i);
						condition += " ";
						condition = condition.substr(5);
						condition = condition.replace(/" t/, "");
						
						icon = String(icon);
						icon = icon.substr(icon.search(/law/)+4);
						icon = icon.substr(0, icon.search(/\"/));
						icon = icon.replace(".gif", ".png");
						iconlocation = "img/weathericons/" + icon;
						icon = "<img src='img/weathericons/" + icon + "' width='90' height='90'>";

						WeatherData[user] = new Array();
						
						WeatherData[user]['city'] = user;
						
						WeatherData[user][0] = new Array();
						WeatherData[user][0]['feels'] = feels;
						WeatherData[user][0]['temp'] = temp;
						WeatherData[user][0]['condition'] = condition;
						WeatherData[user][0]['icon'] = icon;
						WeatherData[user][0]['iconlocation'] = iconlocation;
						//document.getElementById("debug").innerHTML = icon;
						bFoundTodayInfo = true;
					} else  {
						var CData = pRSSChannelItem.childNodes[j].firstChild.data + "";
						var CDataA = CData.split("<");
						var UpcomingArray = new Array();
						var day = "";
						var templo = "";
						var temphi = "";
						var rain = "";
						var pcnt = 0;
						var currentday = 0;
						var icon = "";
						for(xy in CDataA) {
							var p = CDataA[xy];
							if(p.search(/src=rss/) >= 0) {
								day = p.substr(p.indexOf(">")+1,10);
								pcnt++;
							}
							if(p.search(/&#176;/) >= 0) {
								icon = p.match(/saw\/.+\"/i);
								icon = String(icon);
								icon = icon.substr(icon.search(/saw/)+4);
								icon = icon.substr(0, icon.search(/\"/));
								icon = icon.replace(".gif", ".png");
								
								templo = p.substr(p.indexOf("Lo:")+4, 15);
								templo = templo.substr(0, templo.indexOf("&"));
								temphi = p.substr(p.indexOf("Hi:")+4, 15);
								temphi = temphi.substr(0, temphi.indexOf("&"));
								rain = p.substr(p.indexOf("precipitation:")+15, 5);
								pcnt++;
							}
							if(pcnt >= 2) {
								pcnt = 0;
								if(day == "Today") day = myDays[new Date().getDay()];
								if(day == "Tomorrow") day = myDays[(new Date( new Date().getTime()+(24*60*60*1000)) ).getDay()];
								UpcomingArray.push(new Array(day, templo, temphi, rain));
								if(!WeatherData[user][currentday])
									WeatherData[user][currentday] = new Array();
								WeatherData[user][currentday]['day'] = day;
								WeatherData[user][currentday]['temp_min'] = templo;
								WeatherData[user][currentday]['temp_max'] = temphi;
								WeatherData[user][currentday]['rain'] = rain;
								WeatherData[user][currentday]['icon'] = icon;
								currentday++;
							}
						}
					}
				}
			}
		}
	}
	nXmlLoadedCount++;
}

function showTemp(n) {
	document.getElementById("condition").innerHTML = n;
	document.getElementById("conditionShadow").innerHTML = n;
}

function ShowWeatherData(city) {
	var cityname = WeatherData[city]['city'];
	if(cityname.length > 14)
		cityname = cityname.substr(0, 13) + "...";

	document.getElementById("city").innerHTML = cityname;
	document.getElementById("temp").innerHTML = WeatherData[city][0]['temp'];
	document.getElementById("condition").innerHTML = WeatherData[city][0]['condition'];
	document.getElementById("conditionShadow").innerHTML = WeatherData[city][0]['condition'];
	document.getElementById("icon").innerHTML = "<img src='/img/weathericons/" + WeatherData[city][0]['icon'] + "' width='90' height='90'>";

	var strContent = "";

	strContent += drawWeatherBar(WeatherData[city], 70, 35, false, true);
	document.getElementById("upcoming").innerHTML = strContent;
}

function openFlyoutSingle() {
	if(System.Gadget.Settings.read("openFlyoutSingle") == 1)
		openFlyOut();
}
						
function openFlyOut() {
	try {
		if(System.Gadget.Flyout.show == true) {
			System.Gadget.Flyout.show = false;
		} else {
			System.Gadget.Flyout.show = true;
			System.Gadget.Flyout.file = "flyout_details.htm";
			System.Gadget.Flyout.onShow = function() {
				// additional startup code.
			}
		}
	}
	catch (evt) {}
}
