function drawWeatherBar(wData, bwidth, bheight, showIcon, iconChange) {
	var strContent = "";
	var voffset = 0;
	var scale = 0;
	if(System.Gadget.Settings.read("unit") == "c") {
		voffset = 15;
		scale = 1.5;
	} else {
		voffset = 2;
		scale = 2.5;
	}


	var x1 = 0;
	var y1 = bheight - ((parseInt(wData[0]['temp']) / scale) + voffset);
	var y2 = bheight - ((parseInt(wData[0]['temp']) / scale) + voffset);

	var points = "";
	var points2 = "";
	var points3 = "";
	var temps = "";
	for(k = 0; k < wData.length; k++) {
		if(y1 > 40) y1 = 40;
		if(y1 < 0) y1 =0;
		if(y1 > bheight) y1 = bheight;
		points += parseInt(x1) + "," + parseInt(y1) + ", ";
		points2 += parseInt(x1) + "," + parseInt(y1) + ", ";
		points3 += parseInt(x1) + "," + parseInt(y2) + ", ";
		temps += wData[k]['temp_max'] + "=" + parseInt(y1) + " ";
		y1 =  bheight - ((parseInt(wData[k]['temp_max']) / scale) + voffset);
		y2 =  bheight - ((parseInt(wData[k]['temp_min']) / scale) + voffset);
		x1 = parseInt(k * (bwidth/(wData.length-1)));
	}
	points += parseInt(x1) + "," + parseInt(y1) + ", ";
	points += bwidth+","+bheight+",0,"+bheight+",0,0";
	points2 += parseInt(x1) + "," + parseInt(y1);
	points3 += parseInt(x1) + "," + parseInt(y2);
	
	strContent += "<table cellspacing='0' cellpadding='0' border='0' width='100%' height='"+bheight+"'><tr><td valign='bottom' >";
	strContent += "<v:polyline style='position:relative;' points='" + points + "' filled='true' stroked='false' >";
	strContent += "<v:fill Type='Gradient' Angle='0' color='#ffee00' color2='#009900' Focus='100%' opacity='1.3' />";
	strContent += "</v:polyline>";
	//strContent += "<v:polyline style='position:absolute;left:-0px;bottom:0px;' points='" + points3 + "' filled='false' stroked='true' strokeweight='2' strokecolor='#0000ff'/>";
	strContent += "<v:polyline style='position:absolute;left:-0px;' points='" + points2 + "' filled='false' stroked='true' strokeweight='2' strokecolor='#990000' />";
	strContent += "</td></tr></table>";

	for(k = 1; k < wData.length; k++) {
		x1 = parseInt((k-1) * (bwidth/(wData.length-1)));
		var w = parseInt((bwidth/(wData.length-1)));

		var iconOver = "";
		if(iconChange != null) {
			iconOver += "onMouseOver='changeIcon(\""+wData[k]['icon']+"\", \""+wData[k]['temp_max']+"\");'";
			iconOver += "onMouseOut='changeIcon(\""+wData[0]['icon']+"\", \""+wData[0]['temp']+"\");'";
		}
		
		if(showIcon == true) {
			strContent += "<span style='border-left:solid 1px black;position:absolute;left:"+x1+"px;top:0px;width:"+w+"px;z-index:10;'>";
			strContent += "  <span style='position:absolute;z-index:-1;width:"+w+"px;height:" + bheight + "px;overflow:hidden;'>";
			strContent += "    <img src='img/weathericons/" + wData[k]['icon'] + "' width='30' style='position:relative;top:-10px;left:-10px;'>";
			strContent += "  </span>"
			strContent += "  <span class='tempDay' "+iconOver+">";
			strContent +=      wData[k]['day'].substr(0, 2);
			strContent += "    <br>";
			strContent +=      wData[k]['temp_max'].substr(0, 2);
			strContent += "    <br>";
			strContent +=      wData[k]['temp_min'].substr(0, 2);
			strContent += "  </span>"
			strContent += "</span>";
		} else {
			strContent += "<span style='border-left:solid 1px black;position:absolute;left:"+x1+"px;top:0px;width:"+w+"px;' class='tempDay'"+iconOver+">";
			strContent += "  <div onMouseOver='this.className=\"tempBarHover\";' onMouseOut='this.className=\"tempBar\";'>" 
			strContent +=      wData[k]['day'].substr(0, 2);
			strContent += "    <br>";
			strContent +=      wData[k]['temp_max'].substr(0, 2);
			strContent += "    <br>";
			strContent +=      wData[k]['temp_min'].substr(0, 2);
			strContent += "  </div>";
			strContent += "</span>";
		}
	}

	return strContent;
}

function changeIcon(icon, temp) {
	document.getElementById("icon").innerHTML = "<img src='/img/weathericons/" + icon + "' width='90' height='90'>";
	document.getElementById("temp").innerHTML = temp;
}